
;    Trainer for Mario Bros.
;    By The Nutfreak of Freedom Systems.

	.286
        .MODEL tiny
        .STACK

        .CODE
        ORG 5Dh
unload  LABEL BYTE

lf EQU	0Ah
cr EQU	0Dh
w equ word ptr
b equ byte ptr

        .STARTUP
        mov w PSPseg,es
        jmp install


ident    DB 'Trainer for Mario Bros V1.0'
oldint21 DWORD 0
oldint65 DWORD 0
PSPseg   WORD 0
klen equ offset oldint21 - offset ident

myint65 PROC
	pushf
	in al,60h

	cmp al,3bh         ;F1 voor 10 levens
	je levens

	cmp al,3ch         ;F2 voor level terug
	je terug

	cmp al,3dh         ;F3 voor level vooruit
	je vooruit

end_int65:
	popf
	iret

levens:
        push ax
        mov w ds:[6718h],10
        pop ax
        jmp end_int65

terug:
        push ax
        dec w ds:[6728h]
        pop ax
	jmp end_int65

vooruit:
        push ax
        inc w ds:[6728h]
        pop ax
	jmp end_int65

myint65 ENDP

handler21 PROC
        pushf
        push es
        push ds
        push si
        push di
        push dx
        push cx
        jmp checkhandle21

Kaddress DWORD 0

checkhandle21:
        cmp ax,2509h
        je dothatrick
endofmyint21:
        pop cx
        pop dx
        pop di
	pop si
	pop ds
        pop es
        popf
        jmp dword ptr cs:oldint21

dothatrick:
        mov w cs:Kaddress[0],ds
        mov w cs:Kaddress[2],dx
        mov si,dx                       ; ds:si wijst nr begin int 09

        add si,11
        cld
        lodsb
        cmp al,0E4h
        je voor60checken                ; als er E4h staat verder kijken

NotTheRightByte:
        mov ax,2509h                    ; oude ax herstellen
        jmp endofmyint21                ; myint21 afsluiten

voor60checken:

        lodsb
        cmp al,60h
        je gevonden
        jmp NotTheRightByte

gevonden:
        push ds
        pop es
        dec si
        dec si
        mov di,si
        mov al,0CDh
        stosb
        mov al,65h
        stosb
        mov ax,2509h
        jmp endofmyint21

handler21 ENDP

install PROC
        jmp inst_handls

msg     DB "Trainer for Mario Bros (now installed.)",lf,cr
        DB "By The Nutfreak of Freedom Systems",lf,lf,cr
        DB "In game : push F1 to reset lives to 16",lf,cr
        DB "          push F2 to jump level back",lf,cr
        DB "          push F3 to jump level forward",lf,lf,cr
        DB "Be aware.. There are only 5 levels. After that, the program shuts down.",lf,cr
        DB "Have fun!",lf,lf,cr,"$"
lengt   equ $-msg

inst_handls:
        mov al, unload
        cmp al,'u'
        je deinstallit
        cmp al,'U'
        je deinstallit

        call check_inst
        cmp al,0FFh
        je niet_installeren

        push cs
        pop ds
        mov ah,09h
        mov al,0
        mov dx, OFFSET msg
        int 21h               ;display msg

	mov ax,3565h
	int 21h
	mov w oldint65,bx
	mov w oldint65+2,es
	mov ax,2565h
	lea dx,myint65
	int 21h              ;relocate int 65h

        mov ax,3521h
	int 21h
	mov w oldint21,bx
	mov w oldint21+2,es
	mov ax,2521h
	lea dx,handler21
	int 21h               ;relocate int 21h


        mov dx,OFFSET install
        mov cl,4
        shr dx,cl
        inc dx
        mov ax,3100h
        int 21h
niet_installeren:
        .IF al==0FFh
         mov ah,09
         mov dx,OFFSET msg2
         int 21h
        .ENDIF
        mov ax,4C00h
        int 21h

deinstallit:
        jmp go_deinst

msg3    DB "Trainer Mario is now unloaded.",cr,lf,"$"
msg4    DB "Trainer is not detected!! Aborting unload.",cr,lf,"$"

go_deinst:
        call check_inst
        .IF al==0h
	        push ax
	        mov dx,OFFSET msg4
                mov ah,09h
                int 21h
                pop ax
	        jmp niet_installeren
        .ENDIF

        push ds
        push cs
        pop ds
        mov dx,OFFSET msg3
        mov ah,09
        int 21h                 ;Display unload-msg.
        pop ds

        mov ax,3565h
        int 21h         ; adress ophalen in geheugen van int 65 (ES:BX)

        mov dx, w es:[bx-6]
        mov ds, w es:[bx-4]
        mov ax,2565h
        int 21h                 ;restore int 65h   (DS:DX)

        mov dx, w es:[bx-10]
        mov ds, w es:[bx-8]
        mov ax,2521h
        int 21h                 ;restore int 21h

        mov es, es:[bx-2]
        mov ah, 49h
        int 21h

        mov es, es:[2Ch]
        mov ah, 49h
        int 21h

        mov ax,4C00h
        int 21h

Install ENDP

check_inst PROC near
        jmp  ch_l1

msg2    DB "Erm... This trainer is already installed man!",cr,lf
        DB "Deinstall with 'TR-MARIO u'.",cr,lf,lf,"$"

ch_l1:
        mov ax,3565h
	int 21h
	mov di,bx
        sub di,10
        sub di,klen
        mov si, OFFSET ident
	mov cx,klen
	repe cmpsb
        jz alreadythere
        mov al,0
	ret

alreadythere:
        mov al,0FFh
        ret

check_inst ENDP

	END
